# org.pdfclown.documents.contents.composition.PrimitiveComposer Class Reference

Content stream primitive composer.It provides the basic (primitive) operations described by the PDF specification for graphics content composition. More...

List of all members.

## Public Member Functions
objects::ContentObject | Add (objects::ContentObject obj)
| Adds a content object.
void | ApplyMatrix (double a, double b, double c, double d, double e, double f)
| Applies a transformation to the coordinate system from user space to device space [PDF:1.6:4.3.3].
void | ApplyState (ExtGState state)
| Applies the specified state parameters [PDF:1.6:4.3.4].
void | ApplyState (PdfName name)
| Applies the specified state parameters [PDF:1.6:4.3.4].
objects.CompositeObject | Begin (objects.CompositeObject obj)
| Adds a composite object beginning it.
objects::MarkedContent | BeginLayer (PdfName layerName)
| Begins a new layered-content sequence [PDF:1.6:4.10.2].
objects::MarkedContent | BeginLayer (LayerEntity layer)
| Begins a new layered-content sequence [PDF:1.6:4.10.2].
objects::LocalGraphicsState | BeginLocalState ()
| Begins a new nested graphics state context [PDF:1.6:4.3.1].
objects::MarkedContent | BeginMarkedContent (PdfName tag, PdfName propertyListName)
| Begins a new marked-content sequence [PDF:1.6:10.5].
objects::MarkedContent | BeginMarkedContent (PdfName tag, PropertyList propertyList)
| Begins a new marked-content sequence [PDF:1.6:10.5].
objects::MarkedContent | BeginMarkedContent (PdfName tag)
| Begins a new marked-content sequence [PDF:1.6:10.5].
void | Clip ()
| Modifies the current clipping path by intersecting it with the current path [PDF:1.6:4.4.1].
void | ClosePath ()
| Closes the current subpath by appending a straight line segment from the current point to the starting point of the subpath [PDF:1.6:4.4.1].
void | DrawArc (RectangleF location, double startAngle, double endAngle, double branchWidth, double branchRatio)
| Draws an arc.
void | DrawArc (RectangleF location, double startAngle, double endAngle)
| Draws a circular arc.
void | DrawCurve (PointF startPoint, PointF endPoint, PointF startControl, PointF endControl)
| Draws a cubic Bezier curve [PDF:1.6:4.4.1].
void | DrawCurve (PointF endPoint, PointF startControl, PointF endControl)
| Draws a cubic Bezier curve from the current point [PDF:1.6:4.4.1].
void | DrawEllipse (RectangleF location)
| Draws an ellipse.
void | DrawLine (PointF startPoint, PointF endPoint)
| Draws a line [PDF:1.6:4.4.1].
void | DrawLine (PointF endPoint)
| Draws a line from the current point [PDF:1.6:4.4.1].
void | DrawPolygon (PointF[] points)
| Draws a polygon.
void | DrawPolyline (PointF[] points)
| Draws a multiple line.
void | DrawRectangle (RectangleF location, double radius)
| Draws a rounded rectangle.
void | DrawRectangle (RectangleF location)
| Draws a rectangle [PDF:1.6:4.4.1].
void | DrawSpiral (PointF center, double startAngle, double endAngle, double branchWidth, double branchRatio)
| Draws a spiral.
void | End ()
| Ends the current (innermostly-nested) composite object.
void | Fill ()
| Fills the path using the current color [PDF:1.6:4.4.2].
void | FillStroke ()
| Fills and then strokes the path using the current colors [PDF:1.6:4.4.2].
void | Flush ()
| Serializes the contents into the content stream.
| PrimitiveComposer (IContentContext context)
| PrimitiveComposer (ContentScanner scanner)
void | Rotate (double angle, PointF origin)
| Applies a rotation to the coordinate system from user space to device space [PDF:1.6:4.2.2].
void | Rotate (double angle)
| Applies a rotation to the coordinate system from user space to device space [PDF:1.6:4.2.2].
void | Scale (double ratioX, double ratioY)
| Applies a scaling to the coordinate system from user space to device space [PDF:1.6:4.2.2].
void | SetCharSpace (double value)
| Sets the character spacing parameter [PDF:1.6:5.2.1].
void | SetFillColor (colors::Color value)
| Sets the nonstroking color value [PDF:1.6:4.5.7].
void | SetFont (fonts::Font value, double size)
| Sets the font [PDF:1.6:5.2].
void | SetFont (PdfName name, double size)
| Sets the font [PDF:1.6:5.2].
void | SetLineCap (LineCapEnum value)
| Sets the line cap style [PDF:1.6:4.3.2].
void | SetLineDash (LineDash value)
| Sets the line dash pattern [PDF:1.6:4.3.2].
void | SetLineJoin (LineJoinEnum value)
| Sets the line join style [PDF:1.6:4.3.2].
void | SetLineWidth (double value)
| Sets the line width [PDF:1.6:4.3.2].
void | SetMatrix (double a, double b, double c, double d, double e, double f)
| Sets the transformation of the coordinate system from user space to device space [PDF:1.6:4.3.3].
void | SetMiterLimit (double value)
| Sets the miter limit [PDF:1.6:4.3.2].
void | SetStrokeColor (colors::Color value)
| Sets the stroking color value [PDF:1.6:4.5.7].
void | SetTextLead (double value)
| Sets the text leading [PDF:1.6:5.2.4].
void | SetTextRenderMode (TextRenderModeEnum value)
| Sets the text rendering mode [PDF:1.6:5.2.5].
void | SetTextRise (double value)
| Sets the text rise [PDF:1.6:5.2.6].
void | SetTextScale (double value)
| Sets the text horizontal scaling [PDF:1.6:5.2.3].
void | SetWordSpace (double value)
| Sets the word spacing [PDF:1.6:5.2.2].
Link | ShowText (string value, PointF location, XAlignmentEnum xAlignment, YAlignmentEnum yAlignment, double rotation, actions::Action action)
| Shows the link associated to the specified text on the page at the specified location.
Quad | ShowText (string value, PointF location, XAlignmentEnum xAlignment, YAlignmentEnum yAlignment, double rotation)
| Shows the specified text on the page at the specified location [PDF:1.6:5.3.2].
Link | ShowText (string value, PointF location, actions::Action action)
| Shows the link associated to the specified text on the page at the specified location.
Quad | ShowText (string value, PointF location)
| Shows the specified text on the page at the specified location [PDF:1.6:5.3.2].
Link | ShowText (string value, actions::Action action)
| Shows the link associated to the specified text on the page at the current location.
Quad | ShowText (string value)
| Shows the specified text on the page at the current location [PDF:1.6:5.3.2].
void | ShowXObject (XObject value, PointF location, SizeF?size, XAlignmentEnum xAlignment, YAlignmentEnum yAlignment, double rotation)
| Shows the specified external object at the specified position [PDF:1.6:4.7].
void | ShowXObject (PdfName name, PointF location, SizeF?size, XAlignmentEnum xAlignment, YAlignmentEnum yAlignment, double rotation)
| Shows the specified external object at the specified position [PDF:1.6:4.7].
void | ShowXObject (XObject value, PointF location, SizeF?size)
| Shows the specified external object at the specified position [PDF:1.6:4.7].
void | ShowXObject (PdfName name, PointF location, SizeF?size)
| Shows the specified external object at the specified position [PDF:1.6:4.7].
void | ShowXObject (XObject value, PointF location)
| Shows the specified external object at the specified position [PDF:1.6:4.7].
void | ShowXObject (PdfName name, PointF location)
| Shows the specified external object at the specified position [PDF:1.6:4.7].
void | ShowXObject (XObject value)
| Shows the specified external object [PDF:1.6:4.7].
void | ShowXObject (PdfName name)
| Shows the specified external object [PDF:1.6:4.7].
void | StartPath (PointF startPoint)
| Begins a subpath [PDF:1.6:4.4.1].
void | Stroke ()
| Strokes the path using the current color [PDF:1.6:4.4.2].
void | Translate (double distanceX, double distanceY)
| Applies a translation to the coordinate system from user space to device space [PDF:1.6:4.2.2].
## Properties
ContentScanner | Scanner`[get, set]`
| Gets/Sets the content stream scanner.
ContentScanner.GraphicsState | State`[get]`
| Gets the current graphics state [PDF:1.6:4.3].

##

Content stream primitive composer.

It provides the basic (primitive) operations described by the PDF specification for graphics content composition.

This class leverages the object-oriented content stream modelling infrastructure, which encompasses 1st-level content stream objects (operations), 2nd-level content stream objects (graphics objects) and full graphics state support.

## Constructor & Destructor Documentation

org.pdfclown.documents.contents.composition.PrimitiveComposer.PrimitiveComposer | ( | ContentScanner | scanner | ) |

org.pdfclown.documents.contents.composition.PrimitiveComposer.PrimitiveComposer | ( | IContentContext | context | ) |

## Member Function Documentation

objects::ContentObject org.pdfclown.documents.contents.composition.PrimitiveComposer.Add | ( | objects::ContentObject | obj | ) |

Adds a content object.

Returns:
  The added content object.

Referenced by org.pdfclown.documents.contents.entities.JpegImage.ToInlineObject().

void org.pdfclown.documents.contents.composition.PrimitiveComposer.ApplyMatrix | ( | double | a,
|  | double | b,
|  | double | c,
|  | double | d,
|  | double | e,
|  | double | f |
| ) |  |  |

Applies a transformation to the coordinate system from user space to device space [PDF:1.6:4.3.3].

The transformation is applied to the current transformation matrix (CTM) by concatenation, i.e. it doesn't replace it.

Parameters:

  | a | Item 0,0 of the matrix.
  | b | Item 0,1 of the matrix.
  | c | Item 1,0 of the matrix.
  | d | Item 1,1 of the matrix.
  | e | Item 2,0 of the matrix.
  | f | Item 2,1 of the matrix.

See also:
  SetMatrix(double,double,double,double,double,double)

void org.pdfclown.documents.contents.composition.PrimitiveComposer.ApplyState | ( | ExtGState | state | ) |

Applies the specified state parameters [PDF:1.6:4.3.4].

The

    value

is checked for presence in the current resource dictionary: if it isn't available, it's automatically added. If you need to avoid such a behavior, use ApplyState(PdfName).

Parameters:

  | state | State parameters object.

void org.pdfclown.documents.contents.composition.PrimitiveComposer.ApplyState | ( | PdfName | name | ) |

Applies the specified state parameters [PDF:1.6:4.3.4].

Parameters:

  | name | Resource identifier of the state parameters object.

objects.CompositeObject org.pdfclown.documents.contents.composition.PrimitiveComposer.Begin | ( | objects.CompositeObject | obj | ) |

Adds a composite object beginning it.

Returns:
  Added composite object.

See also:
  End()

objects::MarkedContent org.pdfclown.documents.contents.composition.PrimitiveComposer.BeginLayer | ( | PdfName | layerName | ) |

Begins a new layered-content sequence [PDF:1.6:4.10.2].

Parameters:

  | layerName | Resource identifier of the LayerEntity enclosing the layered content.

Returns:
  Added layered-content sequence.

See also:
  End()

objects::MarkedContent org.pdfclown.documents.contents.composition.PrimitiveComposer.BeginLayer | ( | LayerEntity | layer | ) |

Begins a new layered-content sequence [PDF:1.6:4.10.2].

Parameters:

  | layer | Layer entity enclosing the layered content.

Returns:
  Added layered-content sequence.

See also:
  End()

References org.pdfclown.documents.contents.composition.PrimitiveComposer.BeginLayer(), and org.pdfclown.documents.contents.layers.LayerEntity.Membership.

Referenced by org.pdfclown.documents.contents.composition.PrimitiveComposer.BeginLayer().

objects::LocalGraphicsState org.pdfclown.documents.contents.composition.PrimitiveComposer.BeginLocalState | ( |  | ) |

Begins a new nested graphics state context [PDF:1.6:4.3.1].

Returns:
  Added local graphics state object.

See also:
  End()

Referenced by org.pdfclown.documents.contents.entities.EAN13Barcode.ToInlineObject().

objects::MarkedContent org.pdfclown.documents.contents.composition.PrimitiveComposer.BeginMarkedContent | ( | PdfName | tag,
|  | PdfName | propertyListName |
| ) |  |  |

Begins a new marked-content sequence [PDF:1.6:10.5].

Parameters:

  | tag | Marker indicating the role or significance of the marked content.
  | propertyListName | Resource identifier of the PropertyList describing the marked content.

Returns:
  Added marked-content sequence.

See also:
  End()

References org.pdfclown.objects.PdfName.Resources.

objects::MarkedContent org.pdfclown.documents.contents.composition.PrimitiveComposer.BeginMarkedContent | ( | PdfName | tag,
|  | PropertyList | propertyList |
| ) |  |  |

Begins a new marked-content sequence [PDF:1.6:10.5].

Parameters:

  | tag | Marker indicating the role or significance of the marked content.
  | propertyList | PropertyList describing the marked content.

Returns:
  Added marked-content sequence.

See also:
  End()

objects::MarkedContent org.pdfclown.documents.contents.composition.PrimitiveComposer.BeginMarkedContent | ( | PdfName | tag | ) |

Begins a new marked-content sequence [PDF:1.6:10.5].

Parameters:

  | tag | Marker indicating the role or significance of the marked content.

Returns:
  Added marked-content sequence.

See also:
  End()

References org.pdfclown.documents.contents.composition.PrimitiveComposer.BeginMarkedContent().

Referenced by org.pdfclown.documents.contents.composition.PrimitiveComposer.BeginMarkedContent().

void org.pdfclown.documents.contents.composition.PrimitiveComposer.Clip | ( |  | ) |

Modifies the current clipping path by intersecting it with the current path [PDF:1.6:4.4.1].

It can be validly called only just before painting the current path.

void org.pdfclown.documents.contents.composition.PrimitiveComposer.ClosePath | ( |  | ) |

Closes the current subpath by appending a straight line segment from the current point to the starting point of the subpath [PDF:1.6:4.4.1].

void org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawArc | ( | RectangleF | location,
|  | double | startAngle,
|  | double | endAngle,
|  | double | branchWidth,
|  | double | branchRatio |
| ) |  |  |

Draws an arc.

Parameters:

  | location | Arc location.
  | startAngle | Starting angle.
  | endAngle | Ending angle.
  | branchWidth | Distance between the spiral branches. '0' value degrades to a circular arc.
  | branchRatio | Linear coefficient applied to the branch width. '1' value degrades to a constant branch width.

See also:
  Stroke()

References org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawArc().

Referenced by org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawArc().

void org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawArc | ( | RectangleF | location,
|  | double | startAngle,
|  | double | endAngle |
| ) |  |  |

Draws a circular arc.

Parameters:

  | location | Arc location.
  | startAngle | Starting angle.
  | endAngle | Ending angle.

See also:
  Stroke()

References org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawArc().

Referenced by org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawArc().

void org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawCurve | ( | PointF | startPoint,
|  | PointF | endPoint,
|  | PointF | startControl,
|  | PointF | endControl |
| ) |  |  |

Draws a cubic Bezier curve [PDF:1.6:4.4.1].

Parameters:

  | startPoint | Starting point.
  | endPoint | Ending point.
  | startControl | Starting control point.
  | endControl | Ending control point.

See also:
  Stroke()

void org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawCurve | ( | PointF | endPoint,
|  | PointF | startControl,
|  | PointF | endControl |
| ) |  |  |

Draws a cubic Bezier curve from the current point [PDF:1.6:4.4.1].

Parameters:

  | endPoint | Ending point.
  | startControl | Starting control point.
  | endControl | Ending control point.

See also:
  Stroke()

void org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawEllipse | ( | RectangleF | location | ) |

Draws an ellipse.

Parameters:

  | location | Ellipse location.

See also:
  Fill(), FillStroke(), Stroke()

void org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawLine | ( | PointF | startPoint,
|  | PointF | endPoint |
| ) |  |  |

Draws a line [PDF:1.6:4.4.1].

Parameters:

  | startPoint | Starting point.
  | endPoint | Ending point.

See also:
  Stroke()

void org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawLine | ( | PointF | endPoint | ) |

Draws a line from the current point [PDF:1.6:4.4.1].

Parameters:

  | endPoint | Ending point.

See also:
  Stroke()

void org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawPolygon | ( | PointF[] | points | ) |

Draws a polygon.

A polygon is the same as a multiple line except that it's a closed path.

Parameters:

  | points | Points.

See also:
  Fill(), FillStroke(), Stroke()

void org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawPolyline | ( | PointF[] | points | ) |

Draws a multiple line.

Parameters:

  | points | Points.

See also:
  Stroke()

void org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawRectangle | ( | RectangleF | location,
|  | double | radius |
| ) |  |  |

Draws a rounded rectangle.

Parameters:

  | location | Rectangle location.
  | radius | Vertex radius, '0' value degrades to squared vertices.

See also:
  Fill(), FillStroke(), Stroke()

void org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawRectangle | ( | RectangleF | location | ) |

Draws a rectangle [PDF:1.6:4.4.1].

Parameters:

  | location | Rectangle location.

See also:
  Fill(), FillStroke(), Stroke()

References org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawRectangle().

Referenced by org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawRectangle(), and org.pdfclown.documents.contents.entities.EAN13Barcode.ToInlineObject().

void org.pdfclown.documents.contents.composition.PrimitiveComposer.DrawSpiral | ( | PointF | center,
|  | double | startAngle,
|  | double | endAngle,
|  | double | branchWidth,
|  | double | branchRatio |
| ) |  |  |

Draws a spiral.

Parameters:

  | center | Spiral center.
  | startAngle | Starting angle.
  | endAngle | Ending angle.
  | branchWidth | Distance between the spiral branches.
  | branchRatio | Linear coefficient applied to the branch width.

See also:
  Stroke()

void org.pdfclown.documents.contents.composition.PrimitiveComposer.End | ( |  | ) |

Ends the current (innermostly-nested) composite object.

See also:
  Begin(CompositeObject)

Referenced by org.pdfclown.documents.contents.entities.EAN13Barcode.ToInlineObject().

void org.pdfclown.documents.contents.composition.PrimitiveComposer.Fill | ( |  | ) |

Fills the path using the current color [PDF:1.6:4.4.2].

See also:
  SetFillColor(Color)

Referenced by org.pdfclown.documents.contents.entities.EAN13Barcode.ToInlineObject().

void org.pdfclown.documents.contents.composition.PrimitiveComposer.FillStroke | ( |  | ) |

Fills and then strokes the path using the current colors [PDF:1.6:4.4.2].

See also:
  SetFillColor(Color), SetStrokeColor(Color)

void org.pdfclown.documents.contents.composition.PrimitiveComposer.Flush | ( |  | ) |

Serializes the contents into the content stream.

Referenced by org.pdfclown.documents.contents.entities.EAN13Barcode.ToXObject().

void org.pdfclown.documents.contents.composition.PrimitiveComposer.Rotate | ( | double | angle,
|  | PointF | origin |
| ) |  |  |

Applies a rotation to the coordinate system from user space to device space [PDF:1.6:4.2.2].

Parameters:

  | angle | Rotational counterclockwise angle.
  | origin | Rotational pivot point; it becomes the new coordinates origin.

See also:
  ApplyMatrix(double,double,double,double,double,double)

void org.pdfclown.documents.contents.composition.PrimitiveComposer.Rotate | ( | double | angle | ) |

Applies a rotation to the coordinate system from user space to device space [PDF:1.6:4.2.2].

Parameters:

  | angle | Rotational counterclockwise angle.

See also:
  ApplyMatrix(double,double,double,double,double,double)

void org.pdfclown.documents.contents.composition.PrimitiveComposer.Scale | ( | double | ratioX,
|  | double | ratioY |
| ) |  |  |

Applies a scaling to the coordinate system from user space to device space [PDF:1.6:4.2.2].

Parameters:

  | ratioX | Horizontal scaling ratio.
  | ratioY | Vertical scaling ratio.

See also:
  ApplyMatrix(double,double,double,double,double,double)

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetCharSpace | ( | double | value | ) |

Sets the character spacing parameter [PDF:1.6:5.2.1].

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetFillColor | ( | colors::Color | value | ) |

Sets the nonstroking color value [PDF:1.6:4.5.7].

See also:
  SetStrokeColor(Color)

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetFont | ( | fonts::Font | value,
|  | double | size |
| ) |  |  |

Sets the font [PDF:1.6:5.2].

The is checked for presence in the current resource dictionary: if it isn't available, it's automatically added. If you need to avoid such a behavior, use SetFont(PdfName,double).

Parameters:

  | value | Font.
  | size | Scaling factor (points).

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetFont | ( | PdfName | name,
|  | double | size |
| ) |  |  |

Sets the font [PDF:1.6:5.2].

Parameters:

  | name | Resource identifier of the font.
  | size | Scaling factor (points).

Referenced by org.pdfclown.documents.contents.entities.EAN13Barcode.ToInlineObject().

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetLineCap | ( | LineCapEnum | value | ) |

Sets the line cap style [PDF:1.6:4.3.2].

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetLineDash | ( | LineDash | value | ) |

Sets the line dash pattern [PDF:1.6:4.3.2].

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetLineJoin | ( | LineJoinEnum | value | ) |

Sets the line join style [PDF:1.6:4.3.2].

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetLineWidth | ( | double | value | ) |

Sets the line width [PDF:1.6:4.3.2].

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetMatrix | ( | double | a,
|  | double | b,
|  | double | c,
|  | double | d,
|  | double | e,
|  | double | f |
| ) |  |  |

Sets the transformation of the coordinate system from user space to device space [PDF:1.6:4.3.3].

Parameters:

  | a | Item 0,0 of the matrix.
  | b | Item 0,1 of the matrix.
  | c | Item 1,0 of the matrix.
  | d | Item 1,1 of the matrix.
  | e | Item 2,0 of the matrix.
  | f | Item 2,1 of the matrix.

See also:
  ApplyMatrix(double,double,double,double,double,double)

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetMiterLimit | ( | double | value | ) |

Sets the miter limit [PDF:1.6:4.3.2].

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetStrokeColor | ( | colors::Color | value | ) |

Sets the stroking color value [PDF:1.6:4.5.7].

See also:
  SetFillColor(Color)

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetTextLead | ( | double | value | ) |

Sets the text leading [PDF:1.6:5.2.4].

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetTextRenderMode | ( | TextRenderModeEnum | value | ) |

Sets the text rendering mode [PDF:1.6:5.2.5].

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetTextRise | ( | double | value | ) |

Sets the text rise [PDF:1.6:5.2.6].

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetTextScale | ( | double | value | ) |

Sets the text horizontal scaling [PDF:1.6:5.2.3].

void org.pdfclown.documents.contents.composition.PrimitiveComposer.SetWordSpace | ( | double | value | ) |

Sets the word spacing [PDF:1.6:5.2.2].

Link org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowText | ( | string | value,
|  | PointF | location,
|  | XAlignmentEnum | xAlignment,
|  | YAlignmentEnum | yAlignment,
|  | double | rotation,
|  | actions::Action | action |
| ) |  |  |

Shows the link associated to the specified text on the page at the specified location.

Parameters:

  | value | Text to show.
  | location | Anchor position at which showing the text.
  | xAlignment | Horizontal alignment.
  | yAlignment | Vertical alignment.
  | rotation | Rotational counterclockwise angle.
  | action | Action to apply when the link is activated.

Returns:
  Link.

Quad org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowText | ( | string | value,
|  | PointF | location,
|  | XAlignmentEnum | xAlignment,
|  | YAlignmentEnum | yAlignment,
|  | double | rotation |
| ) |  |  |

Shows the specified text on the page at the specified location [PDF:1.6:5.3.2].

Parameters:

  | value | Text to show.
  | location | Anchor position at which showing the text.
  | xAlignment | Horizontal alignment.
  | yAlignment | Vertical alignment.
  | rotation | Rotational counterclockwise angle.

Returns:
  Bounding box vertices in default user space units.

References org.pdfclown.documents.contents.fonts.Font.Encode(), org.pdfclown.documents.contents.fonts.Font.GetAscent(), org.pdfclown.documents.contents.fonts.Font.GetDescent(), org.pdfclown.documents.contents.fonts.Font.GetKernedWidth(), and org.pdfclown.documents.contents.fonts.Font.GetLineHeight().

Link org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowText | ( | string | value,
|  | PointF | location,
|  | actions::Action | action |
| ) |  |  |

Shows the link associated to the specified text on the page at the specified location.

Parameters:

  | value | Text to show.
  | location | Position at which showing the text.
  | action | Action to apply when the link is activated.

Returns:
  Link.

Quad org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowText | ( | string | value,
|  | PointF | location |
| ) |  |  |

Shows the specified text on the page at the specified location [PDF:1.6:5.3.2].

Parameters:

  | value | Text to show.
  | location | Position at which showing the text.

Returns:
  Bounding box vertices in default user space units.

Link org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowText | ( | string | value,
|  | actions::Action | action |
| ) |  |  |

Shows the link associated to the specified text on the page at the current location.

Parameters:

  | value | Text to show.
  | action | Action to apply when the link is activated.

Returns:
  Link.

Quad org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowText | ( | string | value | ) |

Shows the specified text on the page at the current location [PDF:1.6:5.3.2].

Parameters:

  | value | Text to show.

Returns:
  Bounding box vertices in default user space units.

Referenced by org.pdfclown.documents.contents.entities.EAN13Barcode.ToInlineObject().

void org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowXObject | ( | XObject | value,
|  | PointF | location,
|  | SizeF? | size,
|  | XAlignmentEnum | xAlignment,
|  | YAlignmentEnum | yAlignment,
|  | double | rotation |
| ) |  |  |

Shows the specified external object at the specified position [PDF:1.6:4.7].

The is checked for presence in the current resource dictionary: if it isn't available, it's automatically added. If you need to avoid such a behavior, use ShowXObject(PdfName,PointF,SizeF,XAlignmentEnum,YAlignmentEnum,double).

Parameters:

  | value | External object.
  | location | Position at which showing the external object.
  | size | Size of the external object.
  | xAlignment | Horizontal alignment.
  | yAlignment | Vertical alignment.
  | rotation | Rotational counterclockwise angle.

void org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowXObject | ( | PdfName | name,
|  | PointF | location,
|  | SizeF? | size,
|  | XAlignmentEnum | xAlignment,
|  | YAlignmentEnum | yAlignment,
|  | double | rotation |
| ) |  |  |

Shows the specified external object at the specified position [PDF:1.6:4.7].

Parameters:

  | name | Resource identifier of the external object.
  | location | Position at which showing the external object.
  | size | Size of the external object.
  | xAlignment | Horizontal alignment.
  | yAlignment | Vertical alignment.
  | rotation | Rotational counterclockwise angle.

void org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowXObject | ( | XObject | value,
|  | PointF | location,
|  | SizeF? | size |
| ) |  |  |

Shows the specified external object at the specified position [PDF:1.6:4.7].

The is checked for presence in the current resource dictionary: if it isn't available, it's automatically added. If you need to avoid such a behavior, use ShowXObject(PdfName,PointF,SizeF).

Parameters:

  | value | External object.
  | location | Position at which showing the external object.
  | size | Size of the external object.

void org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowXObject | ( | PdfName | name,
|  | PointF | location,
|  | SizeF? | size |
| ) |  |  |

Shows the specified external object at the specified position [PDF:1.6:4.7].

Parameters:

  | name | Resource identifier of the external object.
  | location | Position at which showing the external object.
  | size | Size of the external object.

void org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowXObject | ( | XObject | value,
|  | PointF | location |
| ) |  |  |

Shows the specified external object at the specified position [PDF:1.6:4.7].

The is checked for presence in the current resource dictionary: if it isn't available, it's automatically added. If you need to avoid such a behavior, use ShowXObject(PdfName,PointF).

Parameters:

  | value | External object.
  | location | Position at which showing the external object.

void org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowXObject | ( | PdfName | name,
|  | PointF | location |
| ) |  |  |

Shows the specified external object at the specified position [PDF:1.6:4.7].

Parameters:

  | name | Resource identifier of the external object.
  | location | Position at which showing the external object.

void org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowXObject | ( | XObject | value | ) |

Shows the specified external object [PDF:1.6:4.7].

The is checked for presence in the current resource dictionary: if it isn't available, it's automatically added. If you need to avoid such a behavior, use ShowXObject(PdfName).

Parameters:

  | value | External object.

References org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowXObject().

Referenced by org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowXObject().

void org.pdfclown.documents.contents.composition.PrimitiveComposer.ShowXObject | ( | PdfName | name | ) |

Shows the specified external object [PDF:1.6:4.7].

Parameters:

  | name | Resource identifier of the external object.

void org.pdfclown.documents.contents.composition.PrimitiveComposer.StartPath | ( | PointF | startPoint | ) |

Begins a subpath [PDF:1.6:4.4.1].

Parameters:

  | startPoint | Starting point.

void org.pdfclown.documents.contents.composition.PrimitiveComposer.Stroke | ( |  | ) |

Strokes the path using the current color [PDF:1.6:4.4.2].

See also:
  SetStrokeColor(Color)

void org.pdfclown.documents.contents.composition.PrimitiveComposer.Translate | ( | double | distanceX,
|  | double | distanceY |
| ) |  |  |

Applies a translation to the coordinate system from user space to device space [PDF:1.6:4.2.2].

Parameters:

  | distanceX | Horizontal distance.
  | distanceY | Vertical distance.

See also:
  ApplyMatrix(double,double,double,double,double,double)

## Property Documentation

ContentScanner org.pdfclown.documents.contents.composition.PrimitiveComposer.Scanner`[get, set]`

Gets/Sets the content stream scanner.

Referenced by org.pdfclown.documents.contents.composition.BlockComposer.BlockComposer(), and org.pdfclown.documents.contents.entities.EAN13Barcode.ToInlineObject().

ContentScanner.GraphicsState org.pdfclown.documents.contents.composition.PrimitiveComposer.State`[get]`

Gets the current graphics state [PDF:1.6:4.3].

Copyright 2006-2013 Stefano Chizzolini. For more information, please visit PDF Clown home page.